; WG12864A  PIC18F*
;  LCDinit
;  - LCDcom  W  
;  - LCDdata  W  
;   Displ_Clr
;Displ_Simb  ,  ,  -    ( ,  , )
;Displ_Text  col , row, text     ( ,  , "")
;    !!!!      ...

  Constant  Displ_On = b'00111111'
  Constant  Displ_Off = b'00111110'
  Constant  Displ_Start = b'11000000'		
  Constant  x = .127    ;      0-127
  Constant  y = .63   ;      0 - 63
  Constant  xsimb = 6   ;     
  Constant  ysimb = 8   ;
  
;   
;EN  equ  1
;RS  equ  0  
;CS1  equ  6  
;CS2  equ  7  

  cblock 
;++++++++++   +++++++++++
Regsimb
nCols
nRows
wrData
ColStolb
addrH
addrL
i1
;++++++++++++++++++++++++++++++++++
  endc 

;     
;
#DEFINE  LCDport  PORTD
#DEFINE  BUSY  	7
#DEFINE  RES  	4
#DEFINE  Com_RS 	BCF	PORTE,0	;    - WR=0
#DEFINE  Dat_RS		BSF	PORTE,0	;    - WR=1
#DEFINE  RD_DSPL   	BSF	PORTE,1	;   -DI=1
#DEFINE  WR_DSPL  	BCF	PORTE,1	;   - DI=0


InitLCD macro
	displ_cs 1
    	MOVLW  Displ_On
    	LCDcom  
	displ_cs 2
    	MOVLW  Displ_On
    	LCDcom  
    endm

displ_cs macro cs
	if cs ==1
	MOVLW B'00100000'
	endif
	if cs ==2
	MOVLW B'01000000'
	endif
	CALL displcs
	endm

displcs:
	CLRF	TRISD
	MOVWF	PORTD
	BSF	CS_ADR
	BCF	CS_ADR
	CLRF	PORTD
	RETURN
;+++++++++++  -   +++++++++++
synLCD:            	;  -  
	CLRF	TRISD
	MOVWF  	PORTD      ; cod comand's W->PORT_D
	BSF	CS_DEV
	BSF    EN      	;    
    	BCF    EN      	; 
	SETF    TRISD   ;     
	Com_RS		;
    	RD_DSPL		;  
bs:	BSF    EN      	;       
    	BCF    EN   	
	BTFSC   PORTD,BUSY		;  
    	BRA     bs
	WR_DSPL
	BCF	CS_DEV
    	RETURN
;+++++++++++ comanda LCD (w=cod comand) +++++++++++
LCDcom  macro  
	WR_DSPL
	Com_RS
    	Call  synLCD
    	endm  
        
;+++++++++++ data in LCD (w=data) ++++++++
LCDdata  macro  
	WR_DSPL
    	Dat_RS
    	Call  synLCD
    	endm
    
;+++++++++++   ++++++++    
Displ_Clr  macro
	displ_cs 1
      Call  Clear
	displ_cs 2
      Call  Clear
    endm
    ;   
Clear:
	Movlw    0x40    ;64 
      	MOVWF    nCols   ;++
	Movlw    0x08    ;64 
	MOVWF	nRows	
	CALL	pozSim	;   	
dcmet1:
	MOVLW	h'00'
	LCDdata 
	DECFSZ	nCols,F
	BRA	dcmet1
	Movlw    0x40    ;64 
      	MOVWF    nCols   ;++
	DECF	nRows,F
	CALL	pozSim
	TSTFSZ	nRows
	BRA	dcmet1
 	RETURN 
    

    
;+++++++++    ( ,  , )   ++++++++++++++++++++  
;+++++++++    ->  21 -    ++++++++++++++++
;+++++++++ 8  (  !!!) +++++++++++++++++++++++++++++++++++++++++++  
Displ_Simb  macro  row,  col, simb    ;   
    if (col > .20)              	;  21        
        Clrf    nCols           	; nCols > 21 -> nCols =0 (nCols -  ) 
    else
        Movlw    col*xsimb           	 ;  nCols = col
        Movwf    nCols          ;
    endif
    if (col > .10)              	;  21        
	displ_cs 2         	;
   else
        displ_cs 1
    endif
    if (row > .7)               ;  8      
        Clrf    nRows            ; nRow > 8 -> nRow =0 (nRow -  ) 
    else
        Movlw    row            ;  nRow = row
        Movwf    nRows          ;
    endif
        Movlw    simb            ;  nRow = row
        Movwf    wrData    	;wrData -  ...
	CALL	pozSim
        Call    Simb
    endm

Displ_Reg  macro  row  ,col , simb    ;      ()
    if (col > .20)              	;  21        
        CLRF    nCols           	; nCols > 21 -> nCols =0 (nCols -  ) 
    else
        Movlw    col*xsimb           	 ;  nCols = col
        Movwf    nCols          ;
    endif
    if (col > .10)              	;  21        
        displ_cs 2           	;
    else
        displ_cs 1          	;
    endif
    if (row > .7)               ;  8      
        Clrf    nRows            ; nRow > 8 -> nRow =0 (nRow -  ) 
    else
        Movlw    row            ;  nRow = row
        Movwf    nRows          ;
    endif
	SWAPF	simb,W
	ANDLW	b'00001111'
	MOVWF	Regsimb
	CALL	testW	
	CALL	pozSim
        Call    Simb
	MOVF	simb,W
	ANDLW	b'00001111'
	MOVWF	Regsimb
	CALL	testW	
        Call    Simb
    endm
testW:
	MOVLW	h'9'
	CPFSGT	Regsimb
	BRA	testw1
	MOVLW	h'37'
	BRA	testw2
testw1:
	MOVLW	h'30'
testw2:
	ADDWF	Regsimb,W
	MOVWF	wrData
	RETURN

Displ_Text  macro  row ,col , text    	;
      	local  Stop
      	local  Message
      	local  Start
    
     if (col > .20)              	;  21        
        Clrf    pCols
        Clrf    nCols           	; nCols > 21 -> nCols =0 (nCols -  )
    else
        Movlw  col                        ;  nCols = col
        Movlw    col*xsimb           	 ;  nCols = col
        Movwf    nCols          ;
    endif
 	if (col > .10)              	;  21        
       	displ_cs 2           	;
    	else
       	displ_cs 1          	;
    	endif
    if (row > .7)               	;  8      
        Clrf    nRows            	; nRow > 8 -> nRow =0 (nRow -  ) 
    else
        Movlw    row            	;  nRow = row
        Movwf    nRows           	;
    endif
    	CALL	pozSim
      GOTO  Start  
Message  dt text
Stop     dt 0   ;   
Start
      	Movlw   LOW (Message)    ;  essage  Stop      
      	Movwf    addrL           ;
      	Sublw   LOW (Stop)       ;
      	Movwf   i1               ; -   2 ..      
      	Rrncf   i1,F             ;RETLW !!!!
      	Movlw  HIGH  (Message)
      	Movwf  addrH
      	Call  st                 ;     
      endm      
            
st:
      Call  dat_text
      Movwf  wrData		; wrData = W
      Call   Simb		;    
      ;Call   test_text		;    
      Incf  addrL,F           ;   ..     255      
      Incf  addrL,F
      Btfsc  STATUS,C
      Incf    addrH,F
      Decfsz  i1,F
      Bra    st     
      Return 
      
dat_text:			;    
      MOVFF  addrH,PCLATH
      MOVF  addrL,W
      MOVWF  PCL
      RETURN  
                  
;+++++++++    - ++++++++++++++++++++        
Simb:  
        MOVLW     xsimb           ;     6
	MOVWF      ColStolb        ;ColStolb = 6    
        MOVLW      xsimb*2         ;W=12
        MULWF      wrData          ;wrData = wrData *12    -   +   
        MOVFF      PRODL,wrData    ;PRODL = wrData
        MOVFF      PRODH,PCLATH    ;PCLATH = PRODH    
wr1:
        CALL      test_pozSim       ;    1-  
        CALL      TabSimb         ;    -  shrift.inc
        LCDdata                   ;   - >     W
        INCF       PRODL,F        ;
        INCF       PRODL,F        ;
        BTFSC      STATUS,C
        INCF       PRODH,F          ;       
        INCF       nCols,f        ;    
        DECFSZ     ColStolb,F     ;ColStolb = ColStolb - 1 ->   ,  = 0  ! 
        BRA       wr1     
        RETURN
;+++++++++             ++++++++++++++++++++  
test_pozSim: 
	MOVLW     .64         
        CPFSEQ   nCols         ;   64   ,  nCols > 64  2-   
        Bra       Poz0
	Clrf      nCols
	displ_cs 2
	CALL 	pozSim
	
	RETURN
Poz0:
        MOVLW     .127          
        CPFSEQ    nCols         ;   64   ,  nCols > 128  2-  
        RETURN
        Clrf      nCols  
        Incf      nRows,F 
        Incf      nCols,F
	displ_cs 1
	CALL 	pozSim
	
	RETURN
;+++++++++   ++++++++++++++++++++        
pozSim:
    	Movf  nRows,W
    	Iorlw  B'10111000'   ;   
    	LCDcom  
    	Movf  nCols,W
    	Iorlw  B'01000000'   ;    
    	LCDcom  
    	Return                   

  
 
